#include <iostream.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <time.h>

int met;

double fx(double x)
{
  return pow(sin(sqrt(1 - x)), 2);
}

double integral1(long n, double a, double b, double(*f)(double))
{
  double step = (b - a) / n, pos = a + step, retval = 0;

  while (pos <= b)
  {
    retval += f(pos) * step;
    pos += step;
  }

  return retval;
}

double integral2(long n, double a, double b, double(*f)(double))
{
  double step = (b - a) / n, pos = a + step, retval = 0;

  while (pos <= b)
  {
    retval += f(pos) * step + (f(pos - step) - f(pos)) * step / 2;
    pos += step;
  }

  return retval;
}

double integral3(long n, double a, double b, double(*f)(double))
{
  double h, x, F, I, N;
  h = (b - a) / n / 2;
  x = a;
  F = f(x);
  I = F;
  N = 0;

  do
  {
    x += h;
    F = f(x);
    I += 4 * F;
    N += 2;
    if (N == 2 * n)
    {
      x = b;
      F = f(x);
      I = (I + F) * h / 3;
      return I;
    }
    x += h;
    F = f(x);
    I += 2 * F;
  } while (1);
}

double integral(double a, double b, double (*f)(double))
{
  double I1, I2, (*I)(long, double, double, double (*fb)(double));
  long n = 2;

  switch (met)
  {
    case 0: I = integral1; break;
    case 1: I = integral2; break;
    case 2: I = integral3;
  }

  do
  {
    I1 = I(n, a, b, f);
    n *= 2;
    I2 = I(n, a, b, f);
  } while (fabs(I2 - I1) > 0.0000001);

  return I1;
}

int main(int argc, char *argv[], char *env[])
{
  char *s, *method;
  double a, b, I;
  int i = 0;

  if (argc < 3)
  {
    cout << "\nணࠬ ਡ񭭮 ᫥ ⥣ࠫ 㭪樨\n";
    cout << "ᯮ짮: lr2.exe <a> <b>\n\n";
    cout << "            a - 砫 ࢠ\n";
    cout << "               b -  ࢠ\n";
    return 0;
  }

  while (*env[i])
  {
    s = new char[strlen(env[i]) + 1];
    strcpy(s, env[i]);
    for (int n = 0; n < strlen(s); n++)
      s[n] = toupper(s[n]);
    method = strstr(s, "METHOD");
    if (method != NULL)
    {
      method += 7;
      break;
    }
    delete s;
    i++;
  }
  if (method == NULL)
  {
    cout << "६ 㦥 \"METHOD\"  \n";
    return 1;
  }
  if (strcmp(method, "1") &&
      strcmp(method, "2") &&
      strcmp(method, "3"))
  {
    cout << "⮤ ᫥  ࠢ쭮!\n";
    return 1;
  }

  a = atof(argv[1]);
  b = atof(argv[2]);

  if (a == b)
  {
    cout << "ࢠ  ୮!\n";
    return 1;
  }

  cout << "\nணࠬ ਡ񭭮 ᫥ ⥣ࠫ 㭪樨\n";
  cout << "㭪: y = sin(sqrt(1 - x))^2\n";
  cout << "᫥ ⥣ࠫ 㭪樨  ࢠ";
  cout << " x  (" << a << "," << b << ")\n";
  cout << "᫥   ⮤ ";

  met = *method - '1';

  switch (met)
  {
    case 0: cout << "אַ㣮쭨"; break;
    case 1: cout << "࠯権"; break;
    case 2: cout << "ᮭ";
  }
  cout << ".\n";

  I = integral(a, b, fx);
  cout << ": I = " << I << "\n";
  double prog_time = (double)clock() / (double)CLK_TCK;
  cout << "६ ࠡ ணࠬ " << prog_time << " .\n";

  return 0;
}
